function [M] = sq(J,t)

% -      [M] = sq(J,<t>)
% - M = matrix of all possible row vectors made of t values equal to 1
%       and J-t elements equal to 0. If t is omitted, generates all possible 
%       row vectors of J elements (1,0).

  M=[];
  if J == 0, return; end
  if nargin==2,           
    if t == J,          
      M=ones(1,J); 
    elseif t>1,       
      for i=1:J-t+1, 
        S=sq(J-i,t-1);
        r=size(S,1);
        T=[zeros(r,i-1) ones(r,1) S];
        M=[T;M];
      end
    elseif t==1,             
      M=zeros(J);
      for j=1:J, M(j,J-j+1)=1; end
    else 
      M=zeros(1,J);   
    end
  else                
    if J==1,
      M = [0;1];
    else
      T = sq(J-1);  nt=size(T,1);
      M = [ zeros(nt,1) T; ones(nt,1) T];
    end
  end
